/**
 * Модуль для  раздела "Настройки".
 */

var settings = (function () {
  return {
    codeEditor: null,
         
    /**
     * Инициализирует обработчики для кнопок и элементов раздела.
    */
    init: function() {
      
      // переход во вкладку "Магазин"
      $('.admin-center').on('click', '.section-settings #tab-shop', function(){    
        settings.closeAllTab();
        settings.openTab($(this).attr('id'));
      });

      // переход во вкладку "Система"
      $('.admin-center').on('click', '.section-settings #tab-system', function(){        
        settings.closeAllTab();
        settings.openTab($(this).attr('id'));
      });
      
      // переход во вкладку "шаблон"
      $('.admin-center').on('click', '.section-settings #tab-template', function(){        

        includeJS(mgBaseDir+'/mg-core/script/codemirror/lib/codemirror.js');
        includeJS(mgBaseDir+'/mg-core/script/codemirror/mode/javascript/javascript.js');
        includeJS(mgBaseDir+'/mg-core/script/codemirror/mode/xml/xml.js');
        includeJS(mgBaseDir+'/mg-core/script/codemirror/mode/php/php.js');
        includeJS(mgBaseDir+'/mg-core/script/codemirror/mode/css/css.js');
        includeJS(mgBaseDir+'/mg-core/script/codemirror/mode/clike/clike.js');

        settings.closeAllTab();
        // выбираем первый в наборе файл 
        $('.file-template').eq(0).click();    
        settings.openTab($(this).attr('id'));        
      });
      
      
      // клик по кнопкам файлов шаблона, загружает  содержание файла с сервера
      $('.admin-center').on('click', '.section-settings .file-template', function(){
        admin.indication('error','Ограничено версией');
        return false; 
      });      
      
      $('.admin-center').on('click', '.section-settings #interface', function(){
        settings.closeAllTab();
        settings.openTab($(this).attr('id'));
      });

      $('.admin-center').on('click', '.section-settings #tab-userField', function(){
        settings.closeAllTab();
        settings.openTab($(this).attr('id'));
        userProperty.print();

      });

      $('.admin-center').on('click', '.section-settings #tab-deliveryMethod', function(){
        settings.closeAllTab();
        settings.openTab($(this).attr('id'));
        //settings.getDeliveryArray();
        settings.updataTabs();
      });

      $('.admin-center').on('click', '.section-settings #tab-paymentMethod', function(){
        settings.closeAllTab();
        settings.openTab($(this).attr('id'));
        //settings.getPaymentTable();
        settings.updataTabs();
      });

      $('.admin-center').on('change', '.section-settings  input[name="staticMenu"]', function(){
        admin.fixedMenu($(this).val()=='false'?'true':'false');
      });
      
      $('.admin-center').on('click', '.section-settings .save-settings', function(){
        var tabName = $(this).parent('.main-settings-container').attr('id');
        admin.ajaxRequest({
          mguniqueurl: "action/editSettings",
          options: settings.getAllSetting(tabName)
        },
        function(response) {
          admin.indication(response.status, response.msg);
          settings.checkValidKey();
          $('.tabs-content').animate({opacity: "hide"}, 1000);
          $('.tabs-content').animate({opacity: "show"}, "slow");
        }
       );
      });
      
      
      // сохранение файла шаблона
      $('.admin-center').on('click', '.section-settings .save-file-template', function(){
        var filename = $(this).data('editfilename');
        content = codeEditor.getValue();
        
        admin.ajaxRequest({
          mguniqueurl: "action/saveTemplateFile", 
          content: content,
          filename: filename
        },
        function(response) {
          admin.indication(response.status, response.msg);        
        });
      });
      
      
      //Обработка  нажатия кнопки проверить версию
      $('.admin-center').on('click', '.clearLastUpdate', function(){         
        admin.ajaxRequest({
          mguniqueurl: "action/clearLastUpdate",         
        },
        function(response) {
          //admin.indication(response.status, response.msg);
		  window.location = mgBaseDir+"/mg-admin/";
        }
        );
      });
      
    //Обработка  нажатия кнопки Приступить к обновлению
      $('.admin-center').on('click', '.update-now', function(){
      
        $(this).replaceWith('<span class="waiting-update" style="color: blue">'+lang.WHAITING_UPDATE+'</span>');
        
        var version = $("#lVer").text();
        $('.img-loader').show();
        
        admin.ajaxRequest({
          mguniqueurl: "action/preDownload",
          version: version
        },
        function(response) {
          $('.img-loader').hide();   
          if('error'==response.status){
            admin.indication(response.status, response.msg);            
             $('.error-update').remove();
            $('.waiting-update').replaceWith('\
                    <div style="color: red" class="error-update">'+response.msg+'<br/></div>\
                    <button rel="preDownload" class="update-now">\
                        <span id="go">Приступить к обновлению</span>\
                     </button>');
            
          } else{
            admin.indication(response.status, response.msg);
            $('.waiting-update').remove();
            $("#updataMsg").html('<div style="color: green" class="archive-update-true">'+response.msg+'<br/></div>\
                      <button rel="preDownload" class="update-archive button">\
                        <span id="go">'+lang.APPLY_UPDATE+'</span>\
                     </button>');
            $("#lVer").html(version);
          }  
        admin.initToolTip();
        }
        );
          
      });

      //Обработка  нажатия кнопки Установить обновление
      $('.admin-center').on('click', '.update-archive', function(){
 
        var version = $("#lVer").text();
    
        admin.ajaxRequest({
          mguniqueurl: "action/postDownload",
          version: version
        },
        function(response) {
          admin.indication(response.status, response.msg);    
		  window.location.href = admin.SITE+'/mg-admin';
        }
        );
        return false;
      });
      
      
      // Вызов модального окна при нажатии на кнопку добавления способа доставки.
      $('.admin-center').on('click', '#tab-deliveryMethod-settings .add-new-button', function(){
        settings.openDeliveryModalWindow('add');
      });
      
      // Вызов модального окна при нажатии на кнопку изменения способа доставки.
      $('.admin-center').on('click', '#tab-deliveryMethod-settings .edit-row', function(){
        settings.openDeliveryModalWindow('edit', $(this).attr('id'));
      });
      
      // Сохранение при нажатии на кнопку сохранить в модальном окне способа доставки.
      $('body').on('click', '#tab-deliveryMethod-settings .save-button', function(){
        settings.saveDeliveryMethod($(this).attr('id'));
      });
      
      // Удаление способа доставки.
      $('.admin-center').on('click', '#tab-deliveryMethod-settings .delete-row', function(){
        settings.deleteDelivery($(this).attr('id'));
      });
            
      // Вызов модального окна при нажатии на кнопку изменения способа оплаты.
      $('.admin-center').on('click', '#tab-paymentMethod-settings .edit-row', function(){
        settings.openPaymentModalWindow($(this).attr('id'));
      });
      
      // Сохранение при нажатии на кнопку сохранить в модальном окне способа оплаты
      $('body').on('change', '#tab-shop-settings .watermarkform', function(){        
        settings.addWatermark();
      });     
      
        // Сохранение при нажатии на кнопку сохранить в модальном окне способа оплаты
      $('body').on('click', '#tab-paymentMethod-settings .save-button', function(){
        settings.savePaymentMethod($(this).attr('id'));
      });
      
      updateWaterMark()

    },

    /**
     * Закрывает все табы
    */
    closeAllTab: function() {
     $('.tabs-list li').removeClass('ui-state-active');
     $('.main-settings-container').css('display', 'none');
    },

    /**
     * Открывает все табы
     */
    openTab: function(tab) {
     cookie('setting-active-tab','#'+tab);
     $('#'+tab).parent('li').addClass('ui-state-active');    
     $('#'+tab+'-settings').css('display', 'block');
    },
            
     /**
     * отложенное открытие таба, применяется при перезагрузке
     */
    calbackOpenTab: function() {   
     $(cookie('setting-active-tab')).click();    
    },

    /**
     * Получает значение всех настроек в выбраном табе
     */
    getAllSetting: function(tab) {
      //собираем из таблицы все инпуты с данными, записываим их в виде нативного кода
      var obj ='{';
      $('#'+tab+' .option').each(function(){
        var val = $(this).val();
       // исключение для кодов счетчиков, т.к. в них можгут встретиться запрещенные символы
       if($(this).attr('name')!='widgetCode'){ 
        obj+='"'+$(this).attr('name')+'":"'+val+'",';
       }else{
         obj+='"'+$(this).attr('name')+'":"",';
       }
      });
      obj+='}';
      
   
      obj=eval("(" + obj + ")");
      
      //теперь присваиваем текстовое значение объекту
      obj.widgetCode=$('textarea[name=widgetCode]').val();
   
      return obj;
    },
    
    checkValidKey:function() {
      if(32 == $('.licenceKey').val().length){
        $('.update-now').removeClass('opacity');
        $('.update-now').prop('disabled', false);
        $('.error-key').hide();
      }else{
        $('.update-now').addClass('opacity');
        $('.update-now').prop('disabled', true);
        $('.error-key').show();
      }
    },

    /**
     * Открывает модальное окно способа доставки.
     * type - тип окна, либо для создания нового, либо для редактирования старого.
     */
    openDeliveryModalWindow: function(type, id) {
    settings.clearFileds();   
      switch (type) {
        case 'edit':{          
          $('.deliveryMethod-table-wrapper .delivery-table-icon').text(lang.TITLE_EDIT_DELIVERY);
          $('#add-deliveryMethod-wrapper .save-button').attr("id", id);
          var paymentMethod = $.parseJSON($('tr[id=delivery_'+id+'] td#paymentHideMethod').text());
          $('input[name=deliveryName]').val($('tr[id=delivery_'+id+'] td#deliveryName').text());
          $('input[name=deliveryCost]').val($('tr[id=delivery_'+id+'] td#deliveryCost span.costValue').text());
          $('input[name=deliveryDescription]').val($('tr[id=delivery_'+id+'] td#deliveryDescription').text());
          $('input[name=free]').val($('tr[id=delivery_'+id+'] td.free .costFree').text());
          
          if(1 == $('tr[id=delivery_'+id+'] td#activity').attr('status')){
            $('input[name=deliveryActivity]').prop('checked', true);
          }
          
          //выбор способов оплаты применительно к данному способу доставки
          $.each(paymentMethod, function(paymentId, active) {
            if(1 == active){
              $('#add-deliveryMethod-wrapper #paymentCheckbox input[name='+paymentId+']').prop('checked', true);
            }else{
              $('#add-deliveryMethod-wrapper #paymentCheckbox input[name='+paymentId+']').prop('checked', false);
            }
          });
          
          
          break;
        }
        case 'add':{
          $('.deliveryMethod-table-wrapper .delivery-table-icon').text(lang.TITLE_NEW_DELIVERY);
          break;
        }
        default:{
          user.clearFileds();
          break;
        }
      }

      // Вызов модального окна.
      admin.openModal($('#add-deliveryMethod-wrapper'));


    },

    /**
     * Открывает модальное окно способа оплаты.
     */
    openPaymentModalWindow: function(id) {
     var paramArray = JSON.parse($('tr[id=payment_'+id+'] td#paramHideArray').html());
  
      //проверка ниличия сопособов доставки для данного метода
      
      if('' != $('tr[id=payment_'+id+'] td#deliveryHideMethod').text()){
        
        var deliveryMethod = $.parseJSON($('tr[id=payment_'+id+'] td#deliveryHideMethod').text());
      }

      settings.clearFileds();
      $('.paymentMethod-table-wrapper .payment-table-icon').text(lang.TITLE_EDIT_PAYMENT);
      $('#add-paymentMethod-wrapper .save-button').attr("id", id);
      //подстановка классов иконок
      switch (id){
        case "1":
          var iconClass = 'wm_icon';
          break;
        case "2":
          var iconClass = 'ym_icon';
          break;
        case "5":
          var iconClass = 'robo_icon';
          break;
        case "6":
          var iconClass = 'qiwi_icon';
          break;
        case "8":
          var iconClass = 'sci_icon';
        break;
        default:
          var iconClass = 'default_icon';
      }
      $('#add-paymentMethod-wrapper span#paymentName').html('<span class="'+iconClass+'">'+$('tr[id=payment_'+id+'] td#paymentName').text()+'</span>');
      
      if('' != $('tr[id=payment_'+id+'] td#urlArray').text()){
        var urlArray = $.parseJSON($('tr[id=payment_'+id+'] td#urlArray').text());
        var urlParam = '<span class="custom-text links-text"><strong>Ссылки для указания в сервисе '+$('tr[id=payment_'+id+'] td#paymentName').text()+':</strong></span>';
        var k=1;
        $.each(urlArray, function(name, val) {
          if(k==1){urlParam += '<p class="link-result">'}
          if(k==2){urlParam += '<p class="link-success">'}
          if(k==3){urlParam += '<p class="link-fail">'}
          urlParam += '<span>'+name+'</span>\
                      '+admin.SITE+val+'\
                    </p>';
          k++;
        });
        $('#add-paymentMethod-wrapper #urlParam').html(urlParam);
      }
      //создание списка изменения параметров для данного способа оплаты
      var input = '';
       $('#add-paymentMethod-wrapper #paymentParam').html('');
      $.each(paramArray, function(name, val) {  
         $('#add-paymentMethod-wrapper #paymentParam').append(
          '<label>\n\
            <span class="custom-text">'+name+'</span>\n\
            <input type="text" name="'+name+'" class="product-name-input" value="">\n\
          </label>'
         );
        $('#add-paymentMethod-wrapper #paymentParam input[name="'+name+'"]').val(val);
      });

      
      // вешаем текстовый редактор на поле в реквизитах
      $('textarea[class=product-name-input]').ckeditor();  
      //ниличие сопобов доставки для данного метода
      if(!$.isEmptyObject(deliveryMethod)){
        //выбор способов доставки применительно к данному способу оплаты
        $.each(deliveryMethod, function(deliveryId, active) {
          if(1 == active){
            $('#add-paymentMethod-wrapper #deliveryCheckbox input[name='+deliveryId+']').prop('checked', true);
          }else{
            $('#add-paymentMethod-wrapper #deliveryCheckbox input[name='+deliveryId+']').prop('checked', false);
          }
        });
      }else{
        $('#add-paymentMethod-wrapper #deliveryArray').html(lang.NONE_DELIVERY);
      }
      //выбор активности данного способа оплаты
      if(1 == $('tr[id=payment_'+id+'] td#activity').attr('status')){
        $('input[name=paymentActivity]').prop('checked', true);
      }

      // Вызов модального окна.
      admin.openModal($('.b-modal#add-paymentMethod-wrapper'));

    },

   /**
    * Чистит все поля модального окна
    */
    clearFileds:function() {
      $('input').removeClass('error-input');
      $('input[name=deliveryName]').val('');
      $('input[name=deliveryCost]').val('');
      $('input[name=deliveryDescription]').val('');
      $('input[name=deliveryActivity]').prop('checked', false);
      $('input[name=paymentActivity]').prop('checked', false);
      $('.deliveryMethod').prop('checked', false);
      $('#add-paymentMethod-wrapper #urlParam').html('');
      $('.paymentMethod').prop('checked', false);
      $('.save-button').attr('id','');
      // Стираем все ошибки предыдущего окна если они были.
      $('.errorField').css('display','none');
    },
   /**
    * сохранение способа доставки
    */
    saveDeliveryMethod:function(id) {
      
      // Если поля не верно заполнены, то не отправляем запрос на сервер.
      if(!settings.validForm()){
        return false;
      }
      
      $('.img-loader').show();
      var status="createDelivery";
      //обрабатываем доступные методы оплаты для данного метода доставки
      var paymentMethod='{';
      
      $('#paymentCheckbox input').each(function(){
        
        if($(this).prop('checked')){
          paymentMethod += '"'+$(this).attr('name')+'":1,';
        }else{
          paymentMethod += '"'+$(this).attr('name')+'":0,';
        }
      });
      
      paymentMethod = paymentMethod.substr(0, paymentMethod.length-1); //удаляем последнюю запятую в конце списка
      paymentMethod +='}';
      
      
      if(id){
        status="editDelivery";
      }
      
      
      var deliveryName = $('input[name=deliveryName]').val();
      var deliveryCost = $('input[name=deliveryCost]').val();
      var deliveryDescription = $('input[name=deliveryDescription]').val();
      var free = $('input[name=free]').val();
      var deliveryActivity = 0;
      if($('input[name=deliveryActivity]').prop('checked')){
        deliveryActivity = 1;
      }      
      
      admin.ajaxRequest({
        mguniqueurl: "action/saveDeliveryMethod",
        status: status,
        deliveryName: deliveryName,
        deliveryCost: deliveryCost,
        deliveryDescription: deliveryDescription,
        deliveryActivity: deliveryActivity,
        paymentMethod: paymentMethod,
        deliveryId: id,
        free:free
      },
      function(response) {
        $('.img-loader').hide();
  
        admin.indication(response.status, response.msg);
        if('success' == response.status){
          
          var activity = '<span class="activity-product-false">'+lang.ACTYVITY_FALSE+'</span>';
          if(deliveryActivity){
            activity = '<span class="activity-product-true">'+lang.ACTYVITY_TRUE+'</span>';
          }
          
          if(id){
            response.data.id = id;
          }
          // html верстка для записи в таблицу
          var row='\
            <tr id="delivery_'+response.data.id+'">\
                <td class="deliveryId">'+response.data.id+'</td>\
                <td id="deliveryName">'+deliveryName+'</td>\
                <td id="deliveryCost">\
                  <span class="costValue">'+deliveryCost+'</span> \
                  <span class="currency">'+admin.CURRENCY+'</span>\
                </td>\
                <td id="deliveryDescription">'+deliveryDescription+'</td>\
                <td class="free"><span class="costFree">'+free+'</span> <span class="currency">'+admin.CURRENCY+'</span></td>\
                <td id="activity" status="'+deliveryActivity+'">'+activity+'</td>\
                <td class="actions">\
                  <ul class="action-list">\
                    <li class="edit-row" id="'+response.data.id+'"><a href="javascript:void(0);" title="'+lang.EDIT+'"></a></li>\
                    <li class="delete-row" id="'+response.data.id+'"><a href="javascript:void(0);" title="'+lang.DELETE+'"></a></li>\
                  </ul>\
                </td>\
                <td id="paymentHideMethod" style="display: none">'+paymentMethod+'</td>\
             </tr>';
          
          if($('tr#none_delivery').length){
            $('tr#none_delivery').remove();
          }
          if(id){
            $('.deliveryMethod-tbody tr[id=delivery_'+id+']').replaceWith(row);
          }else{
            $('.deliveryMethod-tbody').append(row);
          }

          admin.closeModal($('.b-modal'));
        }
        
      }
      );
    },
    
   /**
    * сохранение способа оплаты
    */
    savePaymentMethod:function(id) {      
      $('.img-loader').show();
     
      //обрабатываем параметры методов оплаты
      var paymentParam ='{';
      $('#paymentParam input').each(function(){
          paymentParam+='"'+$(this).attr('name')+'":"'+$(this).val().replace(/\\/g, '\\\\\\\\').replace(/"/g, '\\\\$&')+'",';
      });   
      
      paymentParam = paymentParam.substr(0, paymentParam.length-1); //удаляем последнюю запятую в конце списка
      paymentParam+='}';
      
      var deliveryMethod='';
      if(0 != $('#deliveryCheckbox #deliveryArray').find('input').length){
        //обрабатываем доступные методы доставки для данного метода оплаты

        deliveryMethod='{';
        $('#deliveryCheckbox input').each(function(){

          if($(this).prop('checked')){
            deliveryMethod += '"'+$(this).attr('name')+'":1,';
          }else{
            deliveryMethod += '"'+$(this).attr('name')+'":0,';
          }
        });

        deliveryMethod = deliveryMethod.substr(0, deliveryMethod.length-1); //удаляем последнюю запятую в конце списка
        deliveryMethod +='}';
      }
      //активность метода оплаты
      var paymentActivity = 0;
      if($('input[name=paymentActivity]').prop('checked')){
        paymentActivity = 1;
      }

      
      
      admin.ajaxRequest({
        mguniqueurl: "action/savePaymentMethod",
        paymentParam: paymentParam,
        deliveryMethod: deliveryMethod,
        paymentActivity: paymentActivity,
        paymentId: id
      },
      function(response) {
        $('.img-loader').hide();
        admin.indication(response.status, response.msg);
        if('success' == response.status){
          
          var activity = '<span class="activity-product-false">'+lang.ACTYVITY_FALSE+'</span>';
          if(paymentActivity){
            activity = '<span class="activity-product-true">'+lang.ACTYVITY_TRUE+'</span>';
          }
          
          $('tr[id=payment_'+id+'] td#activity').attr('status', paymentActivity);
          $('tr[id=payment_'+id+'] td#activity').html(activity);         
          $('tr[id=payment_'+id+'] td#deliveryHideMethod').text(deliveryMethod);
          $('tr[id=payment_'+id+'] td#paramHideArray').text(response.data.paymentParam);
          admin.closeModal($('.b-modal'));
        }
        
      }
      );
    },
    
    
    
    /**
     * Удаляет способ доставки из БД сайта и таблицы в текущем разделе
     */
    deleteDelivery: function(id) {
      if(confirm(lang.DELETE+'?')){
        admin.ajaxRequest({
          mguniqueurl:"action/deleteDeliveryMethod",
          id: id
        },
        (function(response) {
          admin.indication(response.status, response.msg);
          $('.deliveryMethod-tbody tr[id=delivery_'+id+']').remove();
          
          if($('#tab-deliveryMethod-settings table.main-settings-list tr').length==1){
            var row = '<tr id="none_delivery"><td class="no-delivery" colspan="6">'+lang.NONE_DELIVERY+'</td></tr>';
            $('.deliveryMethod-tbody').append(row);
          }
          
         })
        );
      }
    },
    
    /**
     * Обновляет необходимые поля при переходе по табам
     */
    updataTabs: function() {
      $('.add-new-button').hide();
      admin.ajaxRequest({
        mguniqueurl:"action/getMethodArray"
      },
      function(response) {
        var deliveryArray ='';
        //массив способов доставки
         
        $('.add-new-button').show();
        $.each(response.data.deliveryArray, function(i, delivery) {
          var paymentMethod = delivery.paymentMethod ? delivery.paymentMethod : '{"0":0}';
          //к каждому способу доставки добавляем "привязаные" способы оплаты
          $('tr#delivery_'+delivery.id+' td#paymentHideMethod').text(paymentMethod);
          //формируем список чекбоксов для вставки в модальное окно способов оплаты
          deliveryArray +='\
            <label>\
              <span class="custom-text">'+delivery.name+'</span>\
              <input type="checkbox" name="'+delivery.id+'" class="deliveryMethod">\
            </label>\
          ';
        });
        
        $('#add-paymentMethod-wrapper #deliveryArray').html(deliveryArray);
        
        var paymentArray ='';
        //массив способов оплаты
    
        $.each(response.data.paymentArray, function(i, payment) {
          
          var deliveryMethod = payment.deliveryMethod ? payment.deliveryMethod : '';
          $('tr#payment_'+payment.id+' td#deliveryHideMethod').text(deliveryMethod);
          if(payment.id==3 || payment.id==6 || payment.id==7){
          paymentArray +='\
            <label>\
              <span class="custom-text">'+payment.name+'</span>\
              <input type="checkbox" name="'+payment.id+'" class="paymentMethod">\
            </label>\
          ';
          }
        });
        
        $('#add-deliveryMethod-wrapper #paymentArray').html(paymentArray);

       
      },
      $('.main-settings-list')
      );
    },
    
    validForm : function() {
      $('.errorField').css('display','none');
      $('input').removeClass('error-input');
      var error;
      var cost = $('input[name=deliveryCost]').val();
      if('' == $('input[name=deliveryName]').val()){
        $('input[name=deliveryName]').addClass('error-input');
        $('input[name=deliveryName]').parent("label").find('.errorField').css('display','block');
        error = true;
      }
      
      if('' == cost || 0 != cost*0){
        $('input[name=deliveryCost]').addClass('error-input');
        $('input[name=deliveryCost]').parent("label").find('.errorField').css('display','block');
        error = true;
      }
      
      if('' == $('input[name=deliveryDescription]').val()){
        $('input[name=deliveryDescription]').addClass('error-input');
        $('input[name=deliveryDescription]').parent("label").find('.errorField').css('display','block');
        error = true;
      }
           
      // Проверка поля для бесплатной доставки, является ли текст в него введенный числом.    
      if(isNaN(parseFloat($('input[name=free]').val()))){
        $('input[name=free]').addClass('error-input');
        $('input[name=free]').parent("label").find('.errorField').css('display','block');
        error = true;
      }
      
      if(error == true){
        return false;
      }

      return true;
    },
    
    /**
     * Загружает водяной знак
     */
    addWatermark: function() {
      $('.watermarkform').ajaxForm({
        type:"POST",
        url: "ajax",
        data: {
          mguniqueurl:"action/updateWaterMark"
        },
        cache: false,
        dataType: 'json',
        success: function(response){
          admin.indication(response.status, response.msg);         
          $('.watermark-img').html("");   
          $('.watermark-img').html("<img style=\"max-width:200px;\" src='"+admin.SITE+'/uploads/watermark/watermark.png?='+parseInt(new Date().getTime()/1000)+"'/>"); 
        }
      }).submit();
    }
  }
})();

settings.init();