<?php
/**
 * Файл template.php является каркасом шаблона, содержит основную верстку шаблона.
 * 
 * В этом файле доступны следующие данные:
 * <code>
*   $data['cartCount'] => Количество товаров в корзине.
*   $data['cartPrice'] => Общая стоимость товаров в корзине.
*   $data['currency'] => Валюта магазина.
*   $data['cartData'] => Содержание корзины.
*   $data['categoryList'] => Список категорий.
*   $data['content']  => Содержание страницы.
*   $data['menu'] => Ггоризонтальное меню.
*   $data['thisUser'] => Информация об авторизованном пользователе.
 * </code>
 *   
 *   Получить подробную информацию о каждом элементе массива $data, можно вставив следующую строку кода в верстку файла.
 *   <code>     
 *    <php viewData($data['cartData']); ?>  
 *   </code>
 * 
 *   Вывести содержание элементов массива $data, можно вставив следующую строку кода в верстку файла.
 *   <code>     
 *    <php echo $data['cartData']; ?>  
 *   </code>
 * 
 *   @author Авдеев Марк <mark-avdeev@mail.ru>
 *   @package moguta.cms
 *   @subpackage Views
 */
?>
<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width">
<?php mgMeta(); ?>
<link href="<?php echo PATH_SITE_TEMPLATE ?>/css/jquery.fancybox.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="<?php echo PATH_SITE_TEMPLATE ?>/js/jquery.fancybox.pack.js"></script>
<script type="text/javascript" src="<?php echo PATH_SITE_TEMPLATE ?>/js/jquery-ui-1.10.1.custom.min.js"></script>
<script type="text/javascript" src="<?php echo PATH_SITE_TEMPLATE ?>/js/jquery.bxslider.min.js"></script>
<script type="text/javascript" src="<?php echo SITE ?>/mg-core/script/jquery.maskedinput.min.js"></script>
<script src="<?php echo PATH_SITE_TEMPLATE ?>/js/jquery.cookie.js"></script>
<script type="text/javascript" src="<?php echo PATH_SITE_TEMPLATE ?>/js/script.js"></script>
<!--[if IE 9]>
  <link href="<?php echo PATH_SITE_TEMPLATE ?>/css/ie9.css" rel="stylesheet" type="text/css" />
<![endif]-->
<!--[if IE 8]>
  <link href="<?php echo PATH_SITE_TEMPLATE ?>/css/ie8.css" rel="stylesheet" type="text/css" />
<![endif]-->
<!--[if IE 7]>
  <link href="<?php echo PATH_SITE_TEMPLATE ?>/css/ie7.css" rel="stylesheet" type="text/css" />
<![endif]-->

</head>
<body> 

  <div class="wrapper">
	<div class="container">
		<div class="header">
			<div class="desktop-cart">

			</div>
			<div class="top-contacts">				
				  <?php if($thisUser = $data['thisUser']): ?>
				  <p class="auth">Добро пожаловать <a href="<?php echo SITE?>/personal"><?php echo empty($thisUser->name)?$thisUser->email:$thisUser->name ?></a>, <a href="<?php echo SITE?>/enter?logout=1">выход</a></p>
				  <?php else: ?>
				  <p class="auth"><a href="<?php echo SITE?>/enter">Войти</a> или <a href="<?php echo SITE?>/registration">зарегистрироваться</a></p>
				  <?php endif; ?>

			</div>
			<div class="logo-block">
				<a href="<?php echo SITE?>" title="autoinforms.ru"><img src="<?php echo PATH_SITE_TEMPLATE ?>/images/logo.png" alt="" title="Автозапчасти новые и б/у"></a>
			</div>

				<div class="search-block">
					<form method="get" action="<?php echo SITE?>/catalog" class="search-form">
						<input type="text" autocomplete="off" name="search" class="search-field" value="Ключевое слово" onfocus="if (this.value == 'Ключевое слово') {this.value = '';}" onblur="if (this.value == '') {this.value = 'Ключевое слово';}">
						<input type="submit" class="search-button" value="">
					</form>
					<div class="fastResult">

					</div>
				</div>
			<div class="clear">&nbsp;</div>
			<div class="top-menu">     
				<?php mgMenuFull();?>
			</div><!--end top-menu-->
		</div><!--end header-->
		<!--Mobile top panel-->
		<div class="mobile-top-panel">
			<a href="javascript:void(0);" class="show-menu-toggle"></a>
			<div class="mobile-top-menu">
				<?php mgMenuFull();?>
			</div>
			<div class="mobile-cart">
				<a href="<?php echo SITE ?>/cart">
					<div class="cart small-cart-icon">
						<div class="cart-inner">
							<ul class="cart-list">
								<li class="cart-qty"><span class="countsht"><?php echo $data['cartCount']?$data['cartCount']:0 ?></span> шт.</li>
							</ul>
						</div>
					</div>
				</a>
			</div>
		</div>
		<!--Mobile top panel-->	
		
		<!--Mobile category menu-->
		<div class="mobile-categories">
			<h2>Категории товаров <span class="mobile-white-arrow"></span></h2>
			<ul class="mobile-cat-list">
				<?php echo $data['categoryList'] ?>
			</ul>
		</div>
		<!--Mobile category menu-->	
		<?php if(!URL::isSection(null)) :?>
			<div class="left-block">
				<span class="mobile-menu-toggler"></span>
				<div class="menu-block">
					<h2 class="cat-title">Категории</h2>
					<ul class="cat-list">
						<?php echo $data['categoryList'] ?>
					</ul>
				</div>
               <!--[catalog-filter]-->        
         
			</div>
    
		<?php  endif; ?>
		<?php if(URL::isSection(null)) :?>	
		<!--[slider-action]-->	
		<?php  endif;?>
		
				
		<div class="center">
    	<?php echo $data['content'] ?>     
		</div><!--end center-->
		<div class="clear">&nbsp;</div>
	<a href="http://automaster67.com" target=_blank><img src="/uploads/banner.png"</a></div><!--end container-->
	<center><div class="h-footer"></div></center>
</div><!--end wrapper-->
<div class="footer">
	<div class="copyright"><!--LiveInternet counter--><script type="text/javascript"><!--
document.write("<a href='//www.liveinternet.ru/click' "+
"target=_blank><img src='//counter.yadro.ru/hit?t11.1;r"+
escape(document.referrer)+((typeof(screen)=="undefined")?"":
";s"+screen.width+"*"+screen.height+"*"+(screen.colorDepth?
screen.colorDepth:screen.pixelDepth))+";u"+escape(document.URL)+
";"+Math.random()+
"' alt='' title='LiveInternet: показано число просмотров за 24"+
" часа, посетителей за 24 часа и за сегодня' "+
"border='0' width='40' height='15'><\/a>")
//--></script><!--/LiveInternet-->  Запчасти новые и б/у Смоленск. AUTOINFORMS.RU  &copy; 2014.        Разработка: <a href="http://razrabotka-sajtov67.ru" target= "blank" style="color: #ffffff">Gerasina.</a>   <a href='http://gatehost.ru' target= "blank" style="color: #ffffff">Наш хостинг Gatehost.ru</a></div>
	<div class="powered">  <a href="http://moguta.ru" target="_blank"></a></div>
</div>
<?php echo MG::getSetting('widgetCode'); ?> 
<!-- BEGIN JIVOSITE CODE {literal} -->
<script type='text/javascript'>
(function(){ var widget_id = 'TK29OvERKv';
var s = document.createElement('script'); s.type = 'text/javascript'; s.async = true; s.src = '//code.jivosite.com/script/widget/'+widget_id; var ss = document.getElementsByTagName('script')[0]; ss.parentNode.insertBefore(s, ss);})();</script>
<!-- {/literal} END JIVOSITE CODE -->
</body>
</html>